Strict mode in EJ2 JavaScript TimePicker

04 Sep 20266 minutes to read

The strictMode is an act that allows entering only valid time value within the specified min/max
range in the textbox. If the time value is invalid, the component value sets to the previous value. If the time value is out of range, the component sets the time value to min/max value.

The following example demonstrates the TimePicker in strictMode with min/max range of 10:00 AM to 4:00 PM . It allows entering
only valid time within the specified range. When entering the out-of-range value like 8:00 PM, the value sets to the max time 4:00 PM as the value 8:00 PM is greater than the max value of 4:00 PM. When entering an invalid time value like 9:00 tt, the value sets to the previous value.

ej.base.enableRipple(true);
   
    var timepicker = new ej.calendars.TimePicker({
        placeholder: 'Select a time',
         strictMode: true,
    min: new Date('7/18/2017 10:00 AM'),
    max: new Date('7/18/2017 4:00 PM'),
    value: new Date('7/18/2017 3:00 PM'),
    });    
    timepicker.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 TimePicker control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <!--style reference from the TimePicker component-->
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="style.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="text" id="element">
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

By default, the TimePicker acts in strictMode false state, that allows entering the invalid or out-of-range time in textbox.

If the time is out-of-range or invalid, then the model value will be set to out of range time value or null respectively with the highlighted error class to indicate that the time is out of range or invalid.

The following example demonstrates the strictMode as false. Here, it allows entering the valid or invalid value in textbox. When entering an out-of-range or invalid time value, then the model value will be set to out of range time value or null respectively with the highlighted error class to indicate that the time is out of range or invalid.

ej.base.enableRipple(true);
   
    var timepicker = new ej.calendars.TimePicker({
        placeholder: 'Select a time',     
    min: new Date('7/18/2017 10:00 AM'),
    max: new Date('7/18/2017 4:00 PM'),
    value: new Date('7/18/2017 3:00 PM')
    });    
    timepicker.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 TimePicker control</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <!--style reference from the TimePicker component-->
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="style.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <input type="text" id="element">
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

If the value of the min or max property is changed through code, update the value property to set within the range.

Strict Mode in React TimePicker

The strictMode property enforces validation for time entry within the specified min/max range. When enabled:

  • Invalid time values revert to the previously valid value
  • Out-of-range values adjust to the nearest boundary (min or max)

The following example demonstrates the React TimePicker in strictMode with min/max range of 10:00 AM to 4:00 PM . It allows you to enter only valid time within the specified range. If you enter the out-of-range value like 8:00 PM, the value sets to the max time 4:00 PM as the value 8:00 PM is greater than max value of 4:00 PM. If you enter invalid time value like 9:00 tt, the value sets to the previous value.

[Class-component]

// import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
// import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
// enable ripple effect
enableRipple(true);
export default class App extends React.Component {
    // initialize the min and max time value
    minTime = new Date('8/3/2017 10:00 AM');
    maxTime = new Date('8/3/2017 4:00 PM');
    time = new Date('8/3/2017 8:00 PM');
    render() {
        return <TimePickerComponent id="timepicker" value={this.time} placeholder="Select a Time" min={this.minTime} max={this.maxTime} strictMode={true}/>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('timer'));
// import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
// import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

// enable ripple effect
enableRipple(true);

export default class App extends React.Component<{}, {}> {

    // initialize the min and max time value
    private minTime: Date = new Date('8/3/2017 10:00 AM');
    private maxTime: Date = new Date('8/3/2017 4:00 PM');
    private time: Date = new Date('8/3/2017 8:00 PM');

    public render() {
        return <TimePickerComponent id="timepicker" value={this.time} placeholder="Select a Time" min={this.minTime} max={this.maxTime} strictMode={true} />
    }
};
ReactDOM.render(<App />, document.getElementById('timer'));

[Functional-component]

// import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
// import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
// enable ripple effect
enableRipple(true);
function App() {
    // initialize the min and max time value
    const minTime = new Date('8/3/2017 10:00 AM');
    const maxTime = new Date('8/3/2017 4:00 PM');
    const time = new Date('8/3/2017 8:00 PM');
    return <TimePickerComponent id="timepicker" value={time} placeholder="Select a Time" min={minTime} max={maxTime} strictMode={true}/>;
}
;
ReactDOM.render(<App />, document.getElementById('timer'));
// import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
// import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

// enable ripple effect
enableRipple(true);

function App(){

    // initialize the min and max time value
    const minTime: Date = new Date('8/3/2017 10:00 AM');
    const maxTime: Date = new Date('8/3/2017 4:00 PM');
    const time: Date = new Date('8/3/2017 8:00 PM');

    return <TimePickerComponent id="timepicker" value={time} placeholder="Select a Time" min={minTime} max={maxTime} strictMode={true} />

};
ReactDOM.render(<App />, document.getElementById('timer'));

Default Behavior (strictMode = false)

By default, the React TimePicker operates with strictMode set to false, which allows entry of invalid or out-of-range times. When this occurs:

  • Out-of-range values: Set to the out-of-range time with an error class applied
  • Invalid values: Set to null with an error class applied to indicate validation failure

The following example demonstrates the strictMode as false. Here, it allows to enter the valid or invalid value in textbox. If you are entering the out-of-range or invalid time value, then the model value will be set to out of range time value or null respectively with highlighted error class to indicates the time is out of range or invalid.

[Class-component]

// import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
// import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
// enable ripple effect
enableRipple(true);
export default class App extends React.Component {
    // initialize the min and max time value
    minTime = new Date('8/3/2017 10:00 AM');
    maxTime = new Date('8/3/2017 4:00 PM');
    time = new Date('8/3/2017 8:00 PM');
    render() {
        return <TimePickerComponent id="timepicker" value={this.time} placeholder="Select a Time" min={this.minTime} max={this.maxTime} strictMode={false}/>;
    }
}
;
ReactDOM.render(<App />, document.getElementById('timer'));
// import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
// import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

// enable ripple effect
enableRipple(true);

export default class App extends React.Component<{}, {}> {

    // initialize the min and max time value
    private minTime: Date = new Date('8/3/2017 10:00 AM');
    private maxTime: Date = new Date('8/3/2017 4:00 PM');
    private time: Date = new Date('8/3/2017 8:00 PM');

    public render() {
        return <TimePickerComponent id="timepicker" value={this.time} placeholder="Select a Time" min={this.minTime} max={this.maxTime} strictMode={false} />
    }
};
ReactDOM.render(<App />, document.getElementById('timer'));

[Functional-component]

// import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
// import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";
// enable ripple effect
enableRipple(true);
function App() {
    // initialize the min and max time value
    const minTime = new Date('8/3/2017 10:00 AM');
    const maxTime = new Date('8/3/2017 4:00 PM');
    const time = new Date('8/3/2017 8:00 PM');
    return <TimePickerComponent id="timepicker" value={time} placeholder="Select a Time" min={minTime} max={maxTime} strictMode={false}/>;
}
;
ReactDOM.render(<App />, document.getElementById('timer'));
// import the ripple effect
import { enableRipple } from '@syncfusion/ej2-base';
// import the timepicker
import { TimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from "react";
import * as ReactDOM from "react-dom";

// enable ripple effect
enableRipple(true);

function App() {

    // initialize the min and max time value
    const minTime: Date = new Date('8/3/2017 10:00 AM');
    const maxTime: Date = new Date('8/3/2017 4:00 PM');
    const time: Date = new Date('8/3/2017 8:00 PM');

    return <TimePickerComponent id="timepicker" value={time} placeholder="Select a Time" min={minTime} max={maxTime} strictMode={false} />

};
ReactDOM.render(<App />, document.getElementById('timer'));

If the value of min or max property is changed through code behind, update the value property to set within the range.

Strict Mode in Angular TimePicker

25 Sep 20264 minutes to read

The strictMode is an act that allows you to enter only valid time value within the specified min/max range in the textbox. If the time value is invalid, the component value sets to the previous value.
If the time value is out of range, the component sets the time value to min/max value.

The following example demonstrates the Angular TimePicker in strictMode with min/max range of 10:00 AM to 4:00 PM . It allows you to enter only valid time within the specified range. If you enter the out-of-range value like 8:00 PM, the value sets to the max time 4:00 PM as the value 8:00 PM is greater than max value of 4:00 PM. If you enter invalid time value like 9:00 tt, the value sets to the previous value.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'



import { Component } from '@angular/core';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

@Component({
imports: [
        
        TimePickerModule
    ],


standalone: true,
    selector: 'app-root',
    template: `
        <ejs-timepicker [value]='dateValue' [min]='minValue' [max]='maxValue' [strictMode]='isStrictMode'></ejs-timepicker>
        `
})

export class AppComponent {
    public dateValue: Date = new Date('10/8/2017 3:00 PM');
    public minValue: Date = new Date('10/8/2017 10:00 AM');
    public maxValue: Date = new Date('10/8/2017 4:00 PM');
    public isStrictMode: boolean = true;
    constructor() {
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

By default, the Angular TimePicker act in strictMode false state, that allows to enter the invalid or out-of-range time in textbox.

If the time is out-of-range or invalid, then the model value will be set to out of range time value or null respectively with highlighted error class to indicates the time is out of range or invalid.

The following example demonstrates the strictMode as false. Here, it allows to enter the valid or invalid value in textbox.
If you are entering the out-of-range or invalid time value, then the model value will be set to out of range time value or null respectively with highlighted error class to indicates the time is out of range or invalid.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { TimePickerModule } from '@syncfusion/ej2-angular-calendars'




import { Component } from '@angular/core';
import { enableRipple } from '@syncfusion/ej2-base';

//enable ripple style
enableRipple(true);

@Component({
imports: [
        
        TimePickerModule
    ],


standalone: true,
    selector: 'app-root',
    template: `
        <ejs-timepicker [value]='dateValue' [min]='minValue' [max]='maxValue' [strictMode]='isStrictMode'></ejs-timepicker>
        `
})

export class AppComponent {
    public dateValue: Date = new Date('10/8/2017 4:00 PM');
    public minValue: Date = new Date('10/8/2017 5:00 AM');
    public maxValue: Date = new Date('10/8/2017 10:00 PM');
    public isStrictMode: boolean = false;
    constructor() {
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

If the value of min or max property is changed through code behind, update the value property to set within the range.

Strict Mode in Vue TimePicker

20 Aug 20266 minutes to read

Enable Strict Mode

The strictMode is an act that allows you to enter only valid time value within the specified min/max range in the textbox. If the time value is invalid, the component value sets to the previous value. If the time value is out of range, the component sets the time value to min/max value.

The following example demonstrates the TimePicker in strictMode with min/max range of 10:00 AM to 4:00 PM . It allows you to enter only valid time within the specified range. If you enter the out-of-range value like 8:00 PM, the value sets to the max time 4:00 PM as the value 8:00 PM is greater than max value of 4:00 PM. If you enter invalid time value like 9:00 tt, the value sets to the previous value.

<template>
  <div id="app">
    <div class='wrap'>
      <ejs-timepicker id='timepicker' :strictMode='Strict' :value='timeval' :min='minTime'
        :max='maxTime'></ejs-timepicker>
    </div>
  </div>
</template>
<script setup>

import { TimePickerComponent as EjsTimepicker } from "@syncfusion/ej2-vue-calendars";

const Strict = true;
const timeval = new Date('7/18/2017 3:00 PM');
const minTime = new Date('7/18/2017 10:00 AM');
const maxTime = new Date('7/18/2017 4:00 PM');

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrap {
  margin: 35px auto;
  width: 240px;
}
</style>
<template>
  <div id="app">
    <div class='wrap'>
      <ejs-timepicker id='timepicker' :strictMode='Strict' :value='timeval' :min='minTime'
        :max='maxTime'></ejs-timepicker>
    </div>
  </div>
</template>
<script>

import { TimePickerComponent } from "@syncfusion/ej2-vue-calendars";

export default {
  name: "App",
  components: {
    "ejs-timepicker": TimePickerComponent
  },
  data() {
    return {
      Strict: true,
      timeval: new Date('7/18/2017 3:00 PM'),
      minTime: new Date('7/18/2017 10:00 AM'),
      maxTime: new Date('7/18/2017 4:00 PM')
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrap {
  margin: 35px auto;
  width: 240px;
}
</style>

Disable Strict Mode

By default, the TimePicker act in strictMode false state, that allows to enter the invalid or out-of-range time in textbox.

If the time is out-of-range or invalid, then the model value will be set to out of range time value or null respectively with highlighted error class to indicates the time is out of range or invalid.

The following example demonstrates the strictMode as false. Here, it allows to enter the valid or invalid value in textbox. If you are entering the out-of-range or invalid time value, then the model value will be set toout of range time value or null respectively with highlighted error class to indicates the time is out of range or invalid.

<template>
  <div id="app">
    <div class='wrap'>
      <ejs-timepicker id='timepicker' :value='timeval' :min='minTime' :max='maxTime'></ejs-timepicker>
    </div>
  </div>
</template>
<script setup>

import { TimePickerComponent as EjsTimepicker } from "@syncfusion/ej2-vue-calendars";

const timeval = new Date('7/18/2017 3:00 PM');
const minTime = new Date('7/18/2017 10:00 AM');
const maxTime = new Date('7/18/2017 4:00 PM');

</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrap {
  margin: 35px auto;
  width: 240px;
}
</style>
<template>
  <div id="app">
    <div class='wrap'>
      <ejs-timepicker id='timepicker' :value='timeval' :min='minTime' :max='maxTime'></ejs-timepicker>
    </div>
  </div>
</template>
<script>

import { TimePickerComponent } from "@syncfusion/ej2-vue-calendars";

export default {
  name: "App",
  components: {
    "ejs-timepicker": TimePickerComponent
  },

  data() {
    return {
      timeval: new Date('7/18/2017 3:00 PM'),
      minTime: new Date('7/18/2017 10:00 AM'),
      maxTime: new Date('7/18/2017 4:00 PM')
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";

.wrap {
  margin: 35px auto;
  width: 240px;
}
</style>

If the value of min or max property is changed through code behind, update the value property to set within the range.